import com.atlassian.jira.component.ComponentAccessor
import org.apache.log4j.Logger

nFeed = new nFeedTool()

/**
 * nFeed tool to get data from nFeed custom fields.
 */
class nFeedTool {
	def log = Logger.getLogger(this.getClass())

	/* nFeed API. */
	def nFeedFieldDisplayService
	def nFeedInitialized = false

	/**
	 * Returns the nFeed custom field value as HTML.
	 */
	public def getCustomFieldDisplayHtml(def issue, def customField) {
		// lazily load dependency (attempt only once)
		if(!nFeedInitialized) {
			try {
				def fieldDisplayServiceClass = Class.forName("com.valiantys.nfeed.api.IFieldDisplayService")
				nFeedFieldDisplayService = ComponentAccessor.getOSGiComponentInstanceOfType(fieldDisplayServiceClass)
			} catch (Exception ex) {
				log.warn("Failed to find the nFeed API", ex)
			}
			nFeedInitialized = true
		}

		(nFeedFieldDisplayService != null) ? nFeedFieldDisplayService.getDisplayResult(issue.id, customField.id).getDisplay() : issue.getCustomFieldValue(customField)
	}
}
